/***************************************************************************
 *   Copyright (C) 2004 by Manuel Prez Lpez                              *
 *   mapelo@ieduca.net http://www.ieduca.net/                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GEOMETRIA_H
#define GEOMETRIA_H

#include <qrect.h>
#include <qpoint.h>

/**
@author Manuel Prez Lpez
*/
class geometria  
{
public:
    geometria();
    ~geometria();
    
QRect segRedim (double dist, QRect coord);
QRect segParal (double dist, QRect coord);
QRect arrCoord (double ang, double dist, QRect coord);
double segLong (QRect coord);
QPoint linesCutPoint (QRect coordA, QRect coordB);
QPoint segmentsCutPoint (QRect coordA, QRect coordB);
double arcLong(double ang, double radio);
int isLineCuted (QRect coordA, QRect coordB);
bool isSegmentCuted (QRect coordA, QRect coordB);
double longPointToOrigin(double x, double y, double ox, double oy);

};

#endif
